import { G as useStoreContext, R as Row, L as Label, P as Portal, O as Overlay, a6 as String, a7 as Number, a8 as Boolean, a9 as Select, a as Vector, aa as InnerLabel } from '../../dist/vector-plugin-97a93f9a.esm.js';
export { a0 as LevaInputs, v as SpecialInputs, h as clamp, ad as createPlugin, U as debounce, ac as evaluate, ai as formatVector, g as getVectorPlugin, af as getVectorSchema, ag as getVectorType, j as invertedRange, ae as keyframes, n as normalizeKeyedNumberSettings, aj as normalizeVector, ab as pad, r as range, ah as sanitizeVector, s as styled, H as useCanvas2d, e as useDrag, J as useInput, u as useInputContext, B as useInputSetters, G as useStoreContext, d as useTh, b as useTransform } from '../../dist/vector-plugin-97a93f9a.esm.js';
export { colord } from 'colord';
export { dequal } from 'dequal/lite';
import 'react';
import shallow from 'zustand/shallow';
import '@radix-ui/react-portal';
import 'v8n';
import '@stitches/react';
import '@use-gesture/react';
import '@radix-ui/react-tooltip';

function mergeRefs(refs) {
  return value => {
    refs.forEach(ref => {
      if (typeof ref === 'function') ref(value);else if (ref != null) {
        ref.current = value;
      }
    });
  };
}

const useValue = path => {
  return useValues([path])[path];
};
const useValues = paths => {
  const store = useStoreContext();
  const value = store.useStore(({
    data
  }) => paths.reduce((acc, path) => {
    if (data[path] && 'value' in data[path]) return Object.assign(acc, {
      [path]: data[path].value
    });
    return acc;
  }, {}), shallow);
  return value;
};

const Components = {
  Row,
  Label,
  Portal,
  Overlay,
  String,
  Number,
  Boolean,
  Select,
  Vector,
  InnerLabel
};

export { Components, mergeRefs, useValue, useValues };
